SOCKETPAIR(2) | System Calls Manual | SOCKETPAIR(2)

# NAME

`socketpair` —
create a pair of connected sockets

# LIBRARY

Standard C Library (libc, -lc)

# SYNOPSIS

`#include <sys/socket.h>`

int
`socketpair`(int d, int type, int protocol, int *sv);

# DESCRIPTION

The `socketpair`() call creates an unnamed pair of connected sockets in the specified domain d, of the specified type, and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv`[0]` and sv`[1]`. The two sockets are indistinguishable.

Possible values for the type argument are `SOCK_STREAM`, `SOCK_DGRAM`, and `SOCK_SEQPACKET`; the only supported value for the protocol is 0, which will let the system select an appropriate protocol for the requested socket type.

Any combination of the following flags may additionally be used in the type argument:

`SOCK_CLOEXEC`
  Set close-on-exec flag on both the new descriptors.
`SOCK_NONBLOCK`
  Set non-blocking I/O mode on both the new sockets.

# RETURN VALUES

Upon successful completion, the value 0 is returned; otherwise the value -1 is returned and the global variable errno is set to indicate the error.

# ERRORS

The call succeeds unless:

[`EAFNOSUPPORT`]
  The specified address family is not supported on this machine.
[`EFAULT`]
  The address sv does not specify a valid part of the process address space.
[`EMFILE`]
  Too many descriptors are in use by this process.
[`ENFILE`]
  The system file table is full.
[`EOPNOTSUPP`]
  The specified protocol does not support creation of socket pairs.
[`EPROTONOSUPPORT`]
  The specified protocol is not supported on this machine.

# SEE ALSO

pipe(2), read(2), socket(2), write(2)

# HISTORY

The `socketpair`() function call appeared in 4.2BSD.

Support for the `SOCK_CLOEXEC` and `SOCK_NONBLOCK` flags appeared in NetBSD 6.0.

# BUGS

This call is currently implemented only for the `PF_LOCAL` domain.

November 29, 2022 | NetBSD 10.1